/*****************************************************
CodeWizardAVR V1.24.8d Professional
Chip type           : ATmega128
Clock frequency     : 16,000000 MHz
*****************************************************/
#include <1100.h>
#include <mega128.h>
#include <delay.h>
#include <sdcard.h>
#include "sdcmd.h"
#include <ff.h>
#include "progressor.c"
#include "wave.c"
#include <math.h>
#include <Start_Screen.c>

#define LED PORTA.3
#define ON 1
#define OFF 0
#define NEXT 1
#define PLAY 2
#define STOP 3
#define POWER PORTC.0
#define POWER_BUTTON  PINC.1
#define CHARGE_MODE  PIND  &  0x02
#define CHARGE_OFF()  PORTG |= 0x08
#define CHARGE_ON() PORTG &= 0xF7

//#define SPEED_TEST

//#define DEBUG
#define NOTEST
flash char digit[16]={'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};

/* Timer1 overflow interrupt frequency [Hz] */
#define T1_OVF_FREQ 100
/* Timer1 clock prescaler value */
#define T1_PRESC 1024L
/* Timer1 initialization value after overflow */
#define T1_INIT (0x10000L-(_MCU_CLOCK_FREQUENCY_/(T1_PRESC*T1_OVF_FREQ)))

volatile unsigned char system_sound=0;
volatile unsigned long int sound_length=0;

#define pwm_init() OCR2  = 91; DDRE |= 0x30; TCCR2 = 0x0A; TIMSK  |= 0x80; TCCR3A  = 0xE9; TCCR3B  = 0x01; OCR3BH = 0; OCR3CH = 0

/* error message list */
flash char * flash error_msg[]=
{
"", /* not used */
"FR_DISK_ERR",
"FR_INT_ERR",
"FR_INT_ERR",
"FR_NOT_READY",
"FR_NO_FILE",
"FR_NO_PATH",
"FR_INVALID_NAME",
"FR_DENIED",
"FR_EXIST",
"FR_INVALID_OBJECT",
"FR_WRITE_PROTECTED",
"FR_INVALID_DRIVE",
"FR_NOT_ENABLED",
"FR_NO_FILESYSTEM",
"FR_MKFS_ABORTED",
"FR_TIMEOUT"
};

FIL file;
char buf[2048];
WAVE_INFO wave_header;
unsigned int nbyte=512;
unsigned long int in_file_position;
unsigned int      in_block_position;
unsigned char     bit_per_sample;
unsigned char     channel_number;
static unsigned char     cmd;
unsigned char *sys_arr;
unsigned int bat_voltage;
unsigned int time_out;

//#define LIGHT_ON() OCR3AL = 0xFF; TCCR0 = 0x06; TIMSK |= 1; time_out = 255
#define LIGHT_ON() OCR3AL = 0xFF

/* display error message and stop */
void error(FRESULT res)
{
if ((res>=FR_DISK_ERR) && (res<=FR_TIMEOUT))
   print_message("ERROR: ");
   print_message(error_msg[res]);
/* stop here */
while(1);
}

unsigned char status;

interrupt [TIM0_OVF] void timer0_ovf_sr(void)
{
//time_out = ~time_out & 0x01;
//LED = time_out;
//
//time_out--;
//OCR3AL = 255;
//if (!time_out)
//    TCCR0 = 0;
//    OCR3AL = 0xFF;
//    TIMSK &= 0xFE;

  }

//interrupt [EXT_INT1] void  ext_interrupt_carge_mode(void)
void charge(void)
{char i;
 unsigned int __tmp;
 if (bat_voltage > 400) return;
 OCR3AH = 0;
 OCR3AL = 0;
 delay_ms(300); //delay for anti dgitter
 //EIFR = 0x02;   //clear the interrupt request flag
 while (CHARGE_MODE)
   {
     for (i=0; i<30; i++)
     {
        if (!CHARGE_MODE) return;
        DDRG |= 0x08;
        CHARGE_ON();
        delay_ms(900);
        LED=ON;
        delay_ms(100);
        LED=OFF;
       }; //delay (30sec)
     CHARGE_OFF();
     LED = ON;
     delay_ms(200);
     LED = OFF;
     //battary voltage measure and print
     ADCSRA  = 0x97;
     ADMUX   = 0xE0;
     ADCSRA |= 0x40;
     while ((ADCSRA & (1<<ADIF))==0);
     ADCSRA |= (1<<ADIF);
     bat_voltage = ADCH;
     bat_voltage = bat_voltage*2;

     gotoxy(60,0);
     print_char('v');
     __tmp = bat_voltage;
     for (i=4; i>0; i--)
         {gotoxy(6*(i+5),0);
          if (i == 2) {print_char('.');}
          else {
                 print_char(digit[bat_voltage-(bat_voltage/10)*10]);
                 bat_voltage = bat_voltage/10;
                 };
         };
     bat_voltage = __tmp;

     if (bat_voltage >= 420)  //charge complete;
        {//DDRG &= 0xF7;
         CHARGE_OFF();
         while (CHARGE_MODE)LED = ON;
         LED = OFF;
         return;
         };
//     if (bat_voltage <=300) {delay_ms(1000);}
//        else { if (bat_voltage <=320) {delay_ms(800);}
//                  else { if (bat_voltage <=350) {delay_ms(600);}
//                            else { if (bat_voltage <=370) delay_ms(400);};};};
    };
    LED = OFF;
 }

/* 100Hz timer interrupt generated by ATmega128 Timer1 overflow */
interrupt [TIM1_OVF] void timer_comp_isr(void)
{
/* re-initialize Timer1 */
TCNT1H=T1_INIT>>8;
TCNT1L=T1_INIT&0xFF;
/* card access low level timing function */
disk_timerproc();

/* the rest of the interrupt service routine */
/* .... */
}


/* will hold file/directory information returned by f_readdir*/
FILINFO file_info;


interrupt [TIM2_COMP] void TMR2_inerrupt_service(void)
{
 if (system_sound)
    {
    if (system_sound = 1)
        OCR3BL = (char) start_sound[in_file_position];
    if (system_sound = 2)
        OCR3BL = (char) ding[in_file_position];
    OCR3CL = OCR3BL;
    in_file_position++;
    //*sys_arr++;
    if (in_file_position >= sound_length)
     {//sound end
      TCCR2  = 0x00;
      //TCCR3B = 0x00;
      system_sound = 0;
      in_file_position = 0;
      };
    return;
    };
     if(bit_per_sample == 8)
        {
         OCR3BL = buf[in_block_position];
         in_block_position = in_block_position + channel_number - 1;
         OCR3CL = buf[in_block_position];
         in_block_position++;
         in_file_position += channel_number;
         }
     //if(bit_per_sample == 16)
      else
        {
         in_block_position++;
         OCR3BL = buf[in_block_position];
         in_block_position = in_block_position + channel_number - 1;
         in_block_position = in_block_position + channel_number - 1;
         OCR3CL = buf[in_block_position];
         in_block_position++;
         in_file_position  += (channel_number * 2);
         };
 }


/* recursively scan directory entries and display them */
void directory_scan(char *path)
{
DIR directory;
FRESULT res;
FILINFO list[18];
static unsigned int start_list_index, element_count, position, list_position, win_pos, cnt;
unsigned char i, scroller_pos, buf0_empty, buf1_empty;
unsigned int tmp, razmer_v_popugayax;

//element count scan
element_count = 0;
if ((res=f_opendir(&directory,path))==FR_OK)
   {
   while (((res=f_readdir(&directory,&file_info))==FR_OK) &&
         file_info.fname[0])
         {
          element_count++;
               };
    }

if (element_count == 0)
    {
     gotoxy(0,1);
     print_message("No file found");
     return;
        };

list_position = 0;
position = 0;
start_list_index=0;
win_pos = 0;
cnt = 18;

rd:
start_list_index = position-list_position;
res=f_opendir(&directory,path);
while (((res=f_readdir(&directory,&file_info))==FR_OK) &&
         file_info.fname[0] &&
         cnt > 0)
         {
          if (start_list_index > 0) {start_list_index--;
                                     continue;};
          for (i=0; i<=13; i++)
            {list[18-cnt].fname[i]=file_info.fname[i];
                  };
          cnt--;
               };


loop:
//******************************************
//sub procedure draw list
 //lcd_clear();
 LIGHT_ON();
 for (i=0; i<6; i++)
   {
      gotoxy(0,i+1);
      print_message("             ");
      gotoxy(0,i+1);
      if (list[i].fname[0]) {
      if (i==win_pos)
        print_string(list[list_position-win_pos+i].fname, INVERT);
      else
        print_string(list[list_position-win_pos+i].fname, NORMAL);
         };
    };
//print element_count in left top
tmp = element_count;
for (i = 4; i>0; i--)
        {gotoxy((i-1)*6,0);
         print_char(digit[tmp-(tmp/10)*10]);
         tmp = tmp/10;
          };

//print positon in right top
tmp = position+1;
for (i = 90; i>67; i-=6)
        {gotoxy(i,0);
         print_char(digit[tmp-(tmp/10)*10]);
         tmp = tmp/10;
          };

//print buttons
gotoxy(0,7);
print_message("Up   Play   Down");

//battary voltage measure and print
ADCSRA  = 0x97;
ADMUX   = 0xE0;
ADCSRA |= 0x40;
while ((ADCSRA & (1<<ADIF))==0);
ADCSRA |= (1<<ADIF);
bat_voltage = ADCH;
bat_voltage = bat_voltage*2;

gotoxy(60,0);
print_char('v');
for (i=4; i>0; i--)
    {gotoxy(6*(i+5),0);
     if (i == 2) {print_char('.');}
     else {
            print_char(digit[bat_voltage-(bat_voltage/10)*10]);
            bat_voltage = bat_voltage/10;
            };
     };


//*******************************************
//sub procedure draw vertical scroll bar
tmp = position*46;  //number of dot
scroller_pos = tmp / element_count; //scroller position determinate
for (i=1; i<7; i++)
{ gotoxy(90,i);
  tmp = 0;
  if (scroller_pos <=7) {if (scroller_pos) scroller_pos--;
                         tmp = 0x03 << scroller_pos;
                         scroller_pos = 99;
                        };

    if (i==1) {lcd_write(DATA, 0xFF);
               lcd_write(DATA, (0x01 | tmp));
               lcd_write(DATA, (0x01 | tmp));
               lcd_write(DATA, (0x01 | tmp));
               lcd_write(DATA, 0xFF);}
    else { if(i==6) {lcd_write(DATA, 0xFF);
                     lcd_write(DATA, (0x80 | tmp));
                     lcd_write(DATA, (0x80 | tmp));
                     lcd_write(DATA, (0x80 | tmp));
                     lcd_write(DATA, 0xFF);}
           else {lcd_write(DATA, 0xFF);
                 lcd_write(DATA, tmp);
                 lcd_write(DATA, tmp);
                 lcd_write(DATA, tmp);
                 lcd_write(DATA, 0xFF);};
            };
  scroller_pos -=8;
  };

//*******************************************
while (1)
{
    while (PINE.0 && PINE.1 && PINE.7 && cmd == 0 && POWER_BUTTON == OFF)//;
                   {//battary voltage measure and print
                    if (!tmp) {
                                ADCSRA  = 0x97;
                                ADMUX   = 0xE0;
                                ADCSRA |= 0x40;
                                while ((ADCSRA & (1<<ADIF))==0);
                                ADCSRA |= (1<<ADIF);
                                bat_voltage = ADCH;
                                bat_voltage = bat_voltage*2;
                                gotoxy(60,0);
                                print_char('v');
                                for (i=4; i>0; i--)
                                    {gotoxy(6*(i+5),0);
                                     if (i == 2) {print_char('.');}
                                     else {
                                            print_char(digit[bat_voltage-(bat_voltage/10)*10]);
                                            bat_voltage = bat_voltage/10;
                                            };
                                     };
                                if (OCR3AL) OCR3AL--;
                                tmp = 25500;};
                    tmp--;

                    if (CHARGE_MODE) charge();};

    LIGHT_ON();
    system_sound = 2;
    in_file_position = 0;
    sound_length = 1008;
    pwm_init();

    if ((!PINE.1) || (cmd == NEXT))
                   {  //list scroll down
                    if (cmd == NEXT) cmd = PLAY;
                    if ((list_position < 18) && (position < (element_count-1)))
                         {if (win_pos < 5) win_pos++;
                          list_position++;
                          position++;
                          delay_ms(300);
                          goto loop;}
                    else{ if (position == (element_count-1)) {position = 0;
                                                               list_position = 0;
                                                               win_pos = 0;
                                                               if (cmd == PLAY) cmd = 0;
                                                               goto loop;};

                           if ((position + 9) <= (element_count-1)){
                                                        position++;
                                                        list_position = 8;
                                                        goto rd;
                                                         }
                           else {position++;
                                 list_position = element_count - position;
                                 goto rd;};
                                    };

                    };
    if (!PINE.0) {  //list scroll up
                    if (list_position > 0)
                         {if (win_pos > 0) win_pos--;
                          list_position--;
                          position--;
                          delay_ms(300);
                          goto loop;}
                    else{ if(position > 9) {position--;
                                            list_position = 9;
                                            goto rd;
                                                    }
                           else{ if (position > 0)
                                    {position--;
                                     list_position = position;
                                     goto rd;};
                                 };
                            };
                    };
    if ((!PINE.7) || (cmd == PLAY))
                {
                   system_sound = 0;
                   TCCR2  = 0x00;
                   //TCCR3B = 0x00;
                   res = f_open(&file, list[list_position].fname,1);
                   if (res) error(res);
                   f_read(&file, &wave_header, sizeof(wave_header), &nbyte);
                   lcd_clear();
                   gotoxy(0,1);
                   print_string(list[list_position].fname, NORMAL);
                   gotoxy(0,2);
                   if (wave_header.num_channels == 2) {print_message("stereo");}
                   else print_message("mono");

                   tmp = wave_header.sample_rate;
                   for (i = 24; i>0; i-=6)
                        {gotoxy(i,3);
                         print_char(digit[tmp-(tmp/10)*10]);
                         tmp = tmp/10;
                        };
                    gotoxy(i,3);
                    print_char(digit[tmp-(tmp/10)*10]);
                    gotoxy(31, 3);
                    print_message("Hz ");
                    if (wave_header.bit_per_sample == 8) print_message("8 bit");
                    if (wave_header.bit_per_sample == 16) print_message("16 bit");

                   tmp = wave_header.sample_rate & 0x0000000F;
                   tmp <<= 4;
                   wave_header.sample_rate >>= 4;
                   tmp = tmp + (wave_header.sample_rate & 0x0000000F);
                   tmp <<= 4;
                   wave_header.sample_rate >>= 4;
                   tmp = tmp + (wave_header.sample_rate & 0x0000000F);
                   tmp <<= 4;
                   wave_header.sample_rate >>= 4;
                   tmp = tmp + (wave_header.sample_rate & 0x0000000F);

                   OCR2 = 0;

                   if (tmp == 0x04f1) //8000 hz
                          OCR2  = 250;
                   if (tmp == 0x2265) //22050hZ
                          OCR2  = 91;
                   if (tmp == 0x11b2) //11025hz
                          OCR2  = 181;
                   if (tmp == 0x44CA) //44100hz
                          OCR2  = 45;

                   if (OCR2 == 0)
                       {
                        lcd_clear();
                        gotoxy(0, 3);
                        print_message("  NOT Support!  ");
                        print_message("    press OK    ");
                        gotoxy(0, 7);
                        print_message("      OK        ");
                        while(PINE.7);
                        goto loop;};

                   delay_ms(500);

                   DDRE  |= 0x30;

                   TCCR2 = 0x0A; //kdiv = 8, CTC mode, top on OCR2

                   TIMSK  |= 0x80;   //Timer2 on compare mach interrupt enabled
                   TCCR3A  = 0xE9;   //set A on compare mach clear B out on compare mach, clear C out on compare mach
                   //TCCR3A |= 0x01;
                   TCCR3B  = 0x01;
                   OCR3BH = 0;
                   OCR3CH = 0;
                   channel_number =(unsigned char) wave_header.num_channels;
                   bit_per_sample =(unsigned char) wave_header.bit_per_sample;
                   //snd play
                   progressor_init(6);
                   progressor_pos = 0;
                   progressor_draw();
                   razmer_v_popugayax = wave_header.subchunk2_size/100/2048; //1 persent in blocks
                   tmp = razmer_v_popugayax;
                   progressor_draw();
                   in_file_position = 0;
                   in_block_position = 0;
                   while (in_file_position < wave_header.subchunk2_size)
                      {
                       if (!PINE.7) {TCCR2  = 0x00;
                                     //TCCR3B = 0x00;
                                     delay_ms(300);
                                     lcd_clear();
                                     cmd = 0;
                                     goto loop;};


                       /*double buffering*/
                       while(in_block_position < 1023);
                       f_read(&file, &buf[0], 1024, &nbyte);
                       while(in_block_position < 2047)//;
                            {if(!tmp) {
                                 progressor_increment();
                                 tmp = razmer_v_popugayax; //pa3mepVnonyraRx
                                 };
                                 };

                       in_block_position = 0;
                       f_read(&file, &buf[1024], 1024, &nbyte);
                       tmp--;
                       if (OCR3AL) OCR3AL--;
                       };

                   cmd = NEXT;
                   TCCR2  = 0x00;
                   //TCCR3B = 0x00;
                   delay_ms(300);
                   lcd_clear();
                   goto loop;
                 };
    if (POWER_BUTTON == ON) return;

    };

}


void main(void)
{
unsigned char i,j,k;
/* FAT function result */
FRESULT res;
/* will hold the information for logical drive 0: */
FATFS drive;
/* root directory path */
char path[256]="0:/";

PORTA =0x00;
DDRA  =0x08;
PORTB =0x10;
DDRB  =0x07;
PORTC =0x01;
DDRC  =0x01;
PORTD =0x00;
DDRD  =0x00;
PORTE =0x83;   //Pullup pin0, pin1, pin7
DDRE  =0x08;   //pin0 in, pin1 in, pin7 out
PORTF =0x00;
DDRF  =0xFF;
PORTG =0x00;
DDRG  =0x00;
ASSR  =0x00;
TCCR0 =0x00;
TCNT0 =0x00;
OCR0  =0x00;
TCCR1A=0x00;
TCCR1B=0x04;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H =0x00;
ICR1L =0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;
TCCR2 =0x00;
TCNT2 =0x00;
OCR2  =0x00;
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H =0x00;
ICR3L =0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;
//EICRA =0x0C;   //INT1 rising adge mode
EICRA =0x00;
EICRB =0x00;
//EIMSK =0x02;   //INT 1 enabled (carge mode detect)
EIMSK =0x00;
TIMSK =0x00;
ETIMSK=0x00;
ACSR  =0x80;
SFIOR =0x00;
//SPCR  =0x51;
//SPSR  =0x00;

for (i=255; i>0; i--);
//timeout
LED = ON;
DDRC.1 = 0;
DDRC.0  = 1;
POWER = ON;
while (POWER_BUTTON);
LED = OFF;

// Global enable interrupts
#asm("sei")
#ifndef DEBUG
lcd_init();
//LIGHT_ON();
print_message("Test OK         ");
if (CHARGE_MODE)
    {lcd_clear();
     charge();
     };

//*****************************StartScreen************************

lcd_write(CMD, 0xC8); //mirror Y axis

lcd_clear();
gotoxy(0,6);
for ( j = 0; j < 16; j++)
    for ( i = 0; i < 6; i++ )
				lcd_write(DATA,StartScreen[j][i]);
gotoxy(0,5);
for ( j = 16; j < 32; j++)
    for ( i = 0; i < 6; i++ )
				lcd_write(DATA,StartScreen[j][i]);
gotoxy(0,4);
for ( j = 32; j < 48; j++)
    for ( i = 0; i < 6; i++ )
				lcd_write(DATA,StartScreen[j][i]);
gotoxy(0,3);
for ( j = 48; j < 64; j++)
    for ( i = 0; i < 6; i++ )
				lcd_write(DATA,StartScreen[j][i]);
gotoxy(0,2);
for ( j = 64; j < 80; j++)
    for ( i = 0; i < 6; i++ )
				lcd_write(DATA,StartScreen[j][i]);

delay_ms(1000);
#endif
//start sound
//*sys_arr = &start_sound[0];
system_sound = 1;
in_file_position = 0;
sound_length = 44672;
pwm_init();

for (i=0; i<4; i++)
    {for (j=0; j<10; j++)
        {gotoxy(StarsCoor[i][0], StarsCoor[i][1]);
         for (k = 0; k < 6; k++ )
                lcd_write(DATA,Stars[j][k]);
         delay_ms(100);
         };
     if (i==2)
        {system_sound = 1;
         in_file_position = 0;
         sound_length = 44672;
         pwm_init();
         };
     };
delay_ms(700);

lcd_clear();
lcd_write(CMD, 0xC0);  //NO mirror Y axis
//******************************end start screen******************
//gotoxy(0,0);
//SPCR = 0x53;
//print_message("PORTB Test OK   ");
//print_message("Testing SPI     ");
//print_message("SPCR ");
//print_char(digit[(SPCR>>4)&0x0F]);
//print_char(digit[SPCR&0x0F]);
//print_message(" 1/128 clk ");
//progressor_init(6);
//for (i=0; i<100; i++)
//    {SPDR = i;
//     while(!(SPSR&0x80));
//     progressor_pos = i;
//     progressor_draw();
//     };
//gotoxy(0,5);
//print_message("TEST complete   ");
SPSR |= 0x01;
SPCR  = 0x50;
/* initialize Timer1 overflow interrupts in Mode 0 (Normal) */
TCCR1A=0x00;
/* clkio/1024 */
TCCR1B=(1<<CS12)|(1<<CS10);

/* timer overflow interrupts will occur with 100Hz frequency */
TCNT1H=T1_INIT>>8;
TCNT1L=T1_INIT&0xFF;
/* enable Timer1 overflow interrupt */
TIMSK=1<<TOIE1;
//TIMSK=0x04;

reinit_card:
lcd_clear();
sd_init();
/* initialize SPI interface and card driver */
status=disk_initialize(0);
/* clear the LCD */

/* display disk initialization result on the LCD */
if (status & STA_NOINIT) print_message("Disk init failed");
else
if (status & STA_NODISK) print_message("Card not present");
else
if (status & STA_PROTECT) print_message("Card write\nprotected");
/* all status flags are 0, disk initialization OK */
else print_message("Init OK");
/* wait 2 seconds */
//delay_ms(2000);

/* mount logical drive 0: */
if ((res=f_mount(0,&drive))==FR_OK)
   print_message("Logical drive 0: mounted OK");
else
   /* an error occured, display it and stop */
   error(res);

cmd = 0;
lcd_clear();
/* repeateadly read directory entries and display them */
DDRF  &= 0xFE;
PORTF &= 0xFE;
directory_scan(path);

gotoxy(0,7);
print_char_mode('O', INVERT);
print_char_mode('k', INVERT);
while (1)
      {
      // Place your code here
      if (PINE.0 == 0) goto reinit_card;
      if (CHARGE_MODE) charge();
      if (POWER_BUTTON == ON) {lcd_clear();
                              gotoxy(0,3);
                              print_message("    Good bye    ");
                              POWER = OFF;
                              LED = ON;
                              while (POWER_BUTTON);
                              POWER = OFF;
                             };
      };
}
