//*****************************************************************************************
//  FAT FS module 
//  by Panda 2010 year
//*****************************************************************************************

#include "sdcmd.h"  
                
WORD  _fat_start_sect_;          //fat1 start sector cluster
WORD  _root_start_sect_;         //start sector of root directory
BYTE  _sector_per_cluster_;      //sector per cluster number
WORD  _current_dir_,             //cuddent directory start sector
      _data_start_sect_;         //data arrea start sector
char  _fat_type_[8];              //fat type name 8 symbols
DWORD _disk_size_;                //disk size of Kbyte (only data part)
               

DWORD _f_pos_;                   //position in current file

typedef struct _FILE_STRUCT_ {
        char	fname[11];	/* File name */
        BYTE	fattrib;	/* Attribute */
        WORD	ftime;		/* Last modified time */
	WORD	fdate;		/* Last modified date */
	DWORD	fsize;		/* File size */
	WORD    first_clust;    // first cluster
} FILE;


FILE _file;
  
void mem_copy(void *dest, char buf[], unsigned char pos, unsigned char cnt)
{unsigned char i=0, *ds;
 ds = dest;
 while (cnt)
  {*(char *)ds = buf[pos+i];
   ds++;
   cnt--;
   i++;
   };
}  

unsigned char disk_init()
{
 char buf[512];
 unsigned char err_code, i;
 
 
 err_code = sd_init();
 if (err_code != 0) 
   return err_code;
 disk_read_sector(buf,0);
 _sector_per_cluster_ = buf[0xd];
 for(i=0; i<9; i++) _fat_type_[i]=0;
 for(i=0; i<8; i++) _fat_type_[i]=buf[0x36+i];
 //total sectors
 _disk_size_ = buf[0x23];
 _disk_size_ <<=8;
 _disk_size_ += buf[0x22];
 _disk_size_ <<=8;
 _disk_size_ += buf[0x21];
 _disk_size_ <<=8;
 _disk_size_ += buf[0x20];
                       
 _disk_size_ >>=1;  //convert disk size in sectors to size in Kbyte
 //shift right - is divide by 2. Size of sector is 512 byte.
 _fat_start_sect_ = buf[0xF];
 _fat_start_sect_<<=8;
 _fat_start_sect_ = buf[0xE];
 _root_start_sect_ = buf[0x17]; //sectors per FAT table 
 _root_start_sect_ <<= 8;
 _root_start_sect_ += buf[0x16];
 _root_start_sect_ *= buf[0x10]; //multiply fat count and sectors per fat
 _root_start_sect_ += _fat_start_sect_;
 //_current_dir_ = _root_start_sect_; //root dir is current
 _data_start_sect_   = 0x1F0 + 32;
 return err_code;
 }// end of disk_init()
 
 
 void fopen (char filename[11])
 {
  
  _f_pos_ = 0;
  
  }// end of fopen        */
 
/* //void fread (*FILE file, char buf[], unsigned char cnt)
void fread (FILE file, char buf[], unsigned char cnt)
 { //local variables
   DWORD sect_on_file, 
         sector_on_disk,
         ofset;
   WORD  cluster_on_file,
         cluster_on_disk,
         sector_on_fat;
   unsigned char tmp[2];       
 
   sect_on_file = 0;
   cluster_on_file = 0;
   if (_f_pos_ > 0)
        {
         sect_on_file =  (_f_pos_-1)/512;    
         if (sect_on_file>0)
          cluster_on_file = (sect_on_file-1)/_sector_per_cluster_;
          };
   cluster_on_disk = file.first_clust;       
   while(cluster_on_file > 0)
        {       
         sector_on_fat = _fat_start_sect_ + ((file.first_clust + cluster_on_file) * 2 - 1)/ 512;
         ofset = ((file.first_clust + cluster_on_file) * 2) - (sector_on_fat * 512);
         disk_read_sector(tmp, sector_on_fat, ofset-2 ,2);
         cluster_on_disk = tmp[0];
         cluster_on_disk <<= 8;
         cluster_on_disk += tmp[1];
         };// end of while        
   ofset = sect_on_file - (sect_on_file / _sector_per_cluster_)*_sector_per_cluster_;      
   sector_on_disk = _data_start_sect_ + ((cluster_on_disk-2) * _sector_per_cluster_) + ofset;
   ofset = _f_pos_ - sect_on_file * 512;      
   disk_readp(buf, sector_on_disk, ofset, cnt);
  }//end o fread   */