/*************************************************************************************
  Low level function for sd disk acsess
  by Panda 2010 year april
**************************************************************************************/

#ifndef _sd_cmd_h_

	#define _sd_cmd_h_ 
	#include <delay.h>

	// SD/MMC COMMANDS			ARGUMENT		RESPONSE TYPE		DESCRIPTION
	#define CMD0	0x40		// NO_ARG			RESP_1			GO_IDLE_STATE
	#define CMD1	0x41		// NO_ARG			RESP_1			SEND_OP_COND (ACMD41 = 0x69)
	#define CMD5    0x45
	#define CMD8    0x48
	#define CMD9	0x49		// NO_ARG			RESP_1			SEND_CSD
	#define CMD10	0x4A		// NO_ARG			RESP_1			SEND_CID
	#define CMD12	0x4C		// NO_ARG			RESP_1			STOP_TRANSMISSION
	#define CMD13	0x4D		// NO_ARG			RESP_2			SEND_STATUS
	#define CMD16	0x50		// BLOCK_LEN		RESP_1			SET_BLOCKLEN
	#define CMD17	0x51		// DATA_ADDR		RESP_1			READ_SINGLE_BLOCK
	#define CMD18	0x52		// DATA_ADDR		RESP_1			READ_MULTIPLE_BLOCK
	#define CMD24	0x58		// DATA_ADDR		RESP_1			WRITE_BLOCK
	#define CMD25	0x59		// DATA_ADDR		RESP_1			WRITE_MULTIPLE_BLOCK
	#define CMD27	0x5B		// NO_ARG			RESP_1			PROGRAM_CSD
	#define CMD28	0x5C		// DATA_ADDR		RESP_1b			SET_WRITE_PROT
	#define CMD29	0x5D		// DATA_ADDR		RESP_1b			CLR_WRITE_PROT
	#define CMD30	0x5E		// DATA_ADDR		RESP_1			SEND_WRITE_PROT
	#define CMD32	0x60		// DATA_ADDR		RESP_1			TAG_SECTOR_START
	#define CMD33	0x61		// DATA_ADDR		RESP_1			TAG_SECTOR_END
	#define CMD34	0x62		// DATA_ADDR		RESP_1			UNTAG_SECTOR
	#define CMD35	0x63		// DATA_ADDR		RESP_1			TAG_ERASE_GROUP_START
	#define CMD36	0x64		// DATA_ADDR		RESP_1			TAG_ERASE_GROUP_END
	#define CMD37	0x65		// DATA_ADDR		RESP_1			TAG_ERASE_GROUP
	#define CMD38	0x66		// STUFF_BITS		RESP_1b			ERASE
	#define CMD42	0x6A		// STUFF_BITS		RESP_1b			LOCK_UNLOCK
	#define CMD55   (0x40+55)
	#define CMD58	0x7A		// NO_ARG			RESP_3			READ_OCR
	#define CMD59	0x7B		// STUFF_BITS		RESP_1			CRC_ON_OFF
	#define ACMD41	0x69		// NO_ARG			RESP_1
 
	#define SD_START_TOKEN	0xFE
	#define SD_MULTI_START	0xFC
	#define SD_STOP_TRANS	0xFD

	#define SIGNATURE_WORD	0xAA55  
	
	#define CS PORTB.0             //Chip select port need set as output
	#define ON_DRIVE PIND.0        //Card on drive port need set as output
	#define ind PORTA.3            //Card trafic indicator need set as output
//	#define SPIF 7
	typedef unsigned char BYTE;
	typedef unsigned int  WORD;
	
	typedef unsigned long DWORD;
	               
	void spi_send(BYTE arg)
	{SPDR = arg;
	 //while (!(SPSR & 0x80)); //whate for transmission complete
	 }
	     
	BYTE rcv_byte(void)
	{ind = 0x01;
	 SPDR = 0xFF;
	 while (!(SPSR & (1<<SPIF))); //whate for transmission complete
	 SPDR = 0xFF;
	 while (!(SPSR & (1<<SPIF))); //whate for transmission complete
	 ind = 0x00;
	 return SPDR; 
	 }
	
	unsigned char mmc_send_cmd(BYTE cmd, DWORD param)
	{unsigned char i, r1;
	 if (cmd==ACMD41) {mmc_send_cmd(CMD55, 0x00);};
	 ind = 0x00;   
	 SPDR = cmd;
	 while (!(SPSR & 0x80)); //whate for transmission complete
	 SPDR = (param >> 24) & 0x000000FF;
	 while (!(SPSR & 0x80)); //whate for transmission complete
	 SPDR = (param >> 16) & 0x000000FF;
	 while (!(SPSR & 0x80)); //whate for transmission complete
	 SPDR = (param >> 8) & 0x000000FF;
	 while (!(SPSR & 0x80)); //whate for transmission complete
	 SPDR = param  & 0x000000FF;
	 while (!(SPSR & 0x80)); //whate for transmission complete
	 SPDR = 0x95;
	 while (!(SPSR & 0x80)); //whate for transmission complete
	 ind = 0x01;
	 for (i=0;i<=8;i++)
	  {r1 = rcv_byte();
	   if (r1!=0xFF) break;
	   };
	 return r1;
	 } 
	 
	
	   
        unsigned char sd_init(void)
        {unsigned char i=0, r1; 
         //DDRB |= 0xB0; //Set SS as Out, MISO as input, MOSI as Out, SCK as Out
         //for atmega128
         DDRB |= 0x07; //Set SS as Out, MISO as input, MOSI as Out, SCK as Out
         SPCR=0x53;
         SPSR=0x01;
         // Clear the SPI interrupt flag
         #asm
                in   r30,spsr
                in   r30,spdr
         #endasm
         CS = 0x01;    //set CS 
         delay_ms(10); //whait for card ready 10ms
         
         for(i=0;i<=74;i++) rcv_byte();
         delay_ms(1);  //and whait for 1 ms yet
         CS = 0;
         mmc_send_cmd(CMD0,0x00); //Set for idle state
         for(i=0; i<250; i++)
           {r1 = mmc_send_cmd(ACMD41,0x00);
            if (r1==0x00) break;
            };
         r1=mmc_send_cmd(CMD16,512); //Set block lenght 512 byte   
         return r1;
        }//end of sd_init	                             
        
       /*-----------------------------------------------------------------------*/
       /* Read partial sector                                                   */
       /*-----------------------------------------------------------------------*/

        unsigned char disk_readp (
        unsigned char dest[64],  /* Pointer to the destination object to put data */
 	unsigned long lba,	 /* Start sector number (LBA) */
 	WORD ofs,		 /* Byte offset in the sector (0..511) */
 	WORD cnt		 /* Byte count (1..512), b15:destination flag */
         )
         {
 	BYTE rc;
 	WORD tmr;
 	//BYTE *dat;
 	
         
 	//*dat = *(BYTE*)dest;
 	lba=lba*512;		/* Convert LBA to BA */
 
 	if (mmc_send_cmd(CMD17, lba) == 0) 
 	     {		/* READ_SINGLE_BLOCK */
 		tmr = 30000;
 		ind=0;
  		do {							/* Wait for data packet in timeout of 100ms */
  			//receiving byte
  			SPDR = 0xFF;
	                while (!(SPSR & (1<<SPIF))); //whate for transmission complete
  			rc = SPDR; 
  			//end receiving byte
  			tmr--;
  		} while (rc == 0xFF);// && --tmr);
 
 		if (rc == 0xFE) {
 		        tmr = 0;
 		        while (ofs > 0)
 		        {
 		         //receiving byte
  			 SPDR = 0xFF;
	                 while (!(SPSR & (1<<SPIF))); //whate for transmission complete
  			 rc = SPDR; 
  			 //end receiving byte
 		         ofs--;
 		         tmr++;
 		         };
 		        ofs=0; 
 		        while (cnt > 0)
 		        {
 		         //receiving byte
  			 SPDR = 0xFF;
	                 while (!(SPSR & (1<<SPIF))); //whate for transmission complete
  			 rc = SPDR; 
  			 //end receiving byte
 		         dest[ofs]=rc; //on ever time for debug
 		         ofs++; //for order write
 		         cnt--; //byte receive counter
 		         tmr++; //byte in sector counter
 		        };
 		        while (tmr < 514) 
 		        {
 		         //receiving byte to NILL
  			 SPDR = 0xFF;
	                 while (!(SPSR & (1<<SPIF))); //whate for transmission complete
  			 //end receiving byte to NILL
 		         tmr++;
 		         };
 		}
 	     }
 	     ind=1;
 	return rc;     
         }   
         
       /*-----------------------------------------------------------------------*/
       /* Read sector                                                           */
       /*-----------------------------------------------------------------------*/

        unsigned char disk_read_sector(
        unsigned char dest[512],  /* Pointer to the destination object to put data */
 	unsigned long lba	 /* Start sector number (LBA) */
         )
         {
 	BYTE rc;
 	WORD tmr, cnt;

 	lba=lba*512;		/* Convert LBA to BA */
 
 	if (mmc_send_cmd(CMD17, lba) == 0) 
 	     {		/* READ_SINGLE_BLOCK */
 		tmr = 30000;
 		ind=1;
  		do {							/* Wait for data packet in timeout of 100ms */
  			//receiving byte
  			SPDR = 0xFF;
	                while (!(SPSR & (1<<SPIF))); //whate for transmission complete
  			rc = SPDR; 
  			//end receiving byte
  			tmr--;
  		} while (rc == 0xFF);// && --tmr);
 
 		if (rc == 0xFE) {
 		        tmr = 0;
                        cnt = 512;
 		        while (cnt > 0)
 		        {
 		         //receiving byte
  			 SPDR = 0xFF;
	                 while (!(SPSR & (1<<SPIF))); //whate for transmission complete
  			 rc = SPDR; 
  			 //end receiving byte
 		         dest[512-cnt]=rc; //on ever time for debug
 		         cnt--; //byte receive counter
 		         tmr++; //byte in sector counter
 		        };
 		}
 	     }
 	     ind=0;
 	return rc;     
         }          
#endif
